from peewee import *
from playhouse.pool import PooledMySQLDatabase

database = PooledMySQLDatabase('yixue_test',
                               user='yixue_test',
                               password='Lai123',
                               host='test.db.cxhy.cn',
                               port=3307,
                               max_connections=32,
                               stale_timeout=5, )


class UnknownField(object):
    def __init__(self, *_, **__): pass


class BaseModel(Model):
    class Meta:
        database = database


class AreaInfo(BaseModel):
    hour = IntegerField(null=True)
    jingdu = FloatField(null=True)
    minute = IntegerField(null=True)
    qu = TextField(null=True)
    qu_pinyin = TextField(null=True)
    second = IntegerField(null=True)
    sheng = TextField(null=True)
    shi = TextField(null=True)
    shi_pinyin = TextField(null=True)
    weidu = FloatField(null=True)

    class Meta:
        table_name = 'AreaInfo'


class XingGe(BaseModel):
    key = TextField(null=True)
    level = IntegerField(null=True)
    low = TextField()
    middle = TextField(null=True)
    strong = TextField(null=True)

    class Meta:
        table_name = 'XingGe'


class CustomUser(BaseModel):
    name = TextField(null=True)
    online = IntegerField(null=True)
    psd = TextField(null=True)
    sexy = IntegerField(null=True)
    user = TextField(null=True)

    class Meta:
        table_name = 'custom_user'


class Dashe(BaseModel):
    dizhi = TextField(null=True)
    rigan = TextField(null=True)
    tiangan = TextField(null=True)

    class Meta:
        table_name = 'dashe'


class Diwang(BaseModel):
    dizhi = TextField(null=True)
    nianzhi = TextField(null=True)
    rizhi = TextField(null=True)

    class Meta:
        table_name = 'diwang'


class Dizhi(BaseModel):
    gan1 = TextField(null=True)
    gan2 = TextField(null=True)
    gan3 = TextField(null=True)
    name = TextField()
    wuxing = TextField()
    yinyang_dz = TextField()
    yuefen = IntegerField()

    class Meta:
        table_name = 'dizhi'


class GaonengMid(BaseModel):
    arg1 = TextField(null=True)
    arg2 = TextField(null=True)
    arg3 = TextField(null=True)
    desc = TextField(null=True)
    fangxiang = TextField(null=True)
    father = TextField(null=True)
    guanxi = TextField(null=True)
    hehua = TextField(null=True)
    leibie = TextField(null=True)
    tip = TextField(null=True)
    wuxing1 = TextField(null=True)
    wuxing2 = TextField(null=True)
    wuxing3 = TextField(null=True)

    class Meta:
        table_name = 'gaoneng_mid'


class Huagai(BaseModel):
    dizhi = TextField(null=True)
    nianzhi = TextField(null=True)
    rizhi = TextField(null=True)

    class Meta:
        table_name = 'huagai'


class Liuqin(BaseModel):
    guanxi1 = TextField(null=True)
    guanxi2 = TextField(null=True)
    qiankun = TextField(null=True)
    shishen = TextField(null=True)

    class Meta:
        table_name = 'liuqin'


class LuckyDay(BaseModel):
    day = IntegerField(null=True)
    desc = TextField(null=True)
    jiedu1 = TextField(null=True)
    jiedu2 = TextField(null=True)
    jiedu3 = TextField(null=True)
    jiedu4 = TextField(null=True)
    jiedu5 = TextField(null=True)
    month = IntegerField(null=True)
    riyuan = TextField(null=True)
    tip = TextField(null=True)
    year = IntegerField(null=True)

    class Meta:
        table_name = 'lucky_day'


class LushenTip(BaseModel):
    key = TextField(null=True)
    tip = TextField(null=True)

    class Meta:
        table_name = 'lushen_tip'


class ShenshaTips(BaseModel):
    effects = TextField(null=True)
    shensha = TextField(null=True)
    tips = TextField(null=True)

    class Meta:
        table_name = 'shensha_tips'


class Shishen(BaseModel):
    guanxi = TextField()
    jiancheng = TextField()
    ta = TextField()
    ta_wu_xing = TextField(column_name='taWuXing')
    wo = TextField()
    wo_wu_xing = TextField(column_name='woWuXing')

    class Meta:
        table_name = 'shishen'


class ShishenGeju(BaseModel):
    eft = TextField(null=True)
    key = TextField(null=True)
    solve = TextField(null=True)

    class Meta:
        table_name = 'shishen_geju'


class ShishenJiedu(BaseModel):
    arg1 = TextField(null=True)
    arg2 = TextField(null=True)
    guanxi = TextField(null=True)
    tip1 = TextField(null=True)
    tip2 = TextField()
    tip3 = TextField(null=True)
    tip4 = TextField(null=True)
    tip5 = TextField(null=True)

    class Meta:
        table_name = 'shishen_jiedu'


class ShishenShehuiguanxi(BaseModel):
    guanxi = TextField(null=True)
    shishen = TextField(null=True)

    class Meta:
        table_name = 'shishen_shehuiguanxi'


class ShishenZhenjia(BaseModel):
    jia = TextField(null=True)
    key = TextField(null=True)
    zhen = TextField(null=True)

    class Meta:
        table_name = 'shishen_zhenjia'


class Shishenzhilu(BaseModel):
    dizhi = TextField(null=True)
    tiangan = TextField(null=True)

    class Meta:
        table_name = 'shishenzhilu'


class Taiyangpianyi(BaseModel):
    day = IntegerField(null=True)
    diff = IntegerField(null=True)
    month = IntegerField(null=True)

    class Meta:
        table_name = 'taiyangpianyi'


class Taohua(BaseModel):
    dizhi = TextField(null=True)
    nianzhi = TextField(null=True)
    rizhi = TextField(null=True)

    class Meta:
        table_name = 'taohua'


class Tiangan(BaseModel):
    banlu1 = TextField(null=True)
    banlu2 = TextField(null=True)
    diwang = TextField()
    linguan = TextField()
    lushen = TextField()
    name = TextField()
    wenchang = TextField()
    wuxing = TextField()
    yinyang = TextField()

    class Meta:
        table_name = 'tiangan'


class Tianyiguiren(BaseModel):
    dizhi = TextField(null=True)
    niangan = TextField(null=True)
    rigan = TextField(null=True)

    class Meta:
        table_name = 'tianyiguiren'


class ZaneTest(BaseModel):
    a = IntegerField(null=True)

    class Meta:
        table_name = "zane_test"


class UserInfo(BaseModel):
    beizhu = TextField(null=True)
    customer = TextField(null=True)
    day = IntegerField(null=True)
    enabled = IntegerField(null=True)
    hour = IntegerField(null=True)
    join_time = TextField(column_name='joinTime', null=True)
    leibie = IntegerField(null=True)
    man = IntegerField(null=True)
    minute = IntegerField(null=True)
    month = IntegerField(null=True)
    name = TextField(null=True)
    niangan = TextField(null=True)
    nianzhi = TextField(null=True)
    qu = TextField(null=True)
    rigan = TextField(null=True)
    rizhi = TextField(null=True)
    sheng = TextField(null=True)
    shi = TextField(null=True)
    shigan = TextField(null=True)
    shizhi = TextField(null=True)
    year = IntegerField(null=True)
    yuegan = TextField(null=True)
    yuezhi = TextField(null=True)

    class Meta:
        table_name = 'user_info'


class Wannianli(BaseModel):
    nian = IntegerField()
    nian_gan = TextField(null=True)
    nian_zhi = TextField(null=True)
    ri = IntegerField()
    ri_gan = TextField(null=True)
    ri_zhi = TextField(null=True)
    yue = IntegerField()
    yue_gan = TextField(null=True)
    yue_zhi = TextField(null=True)

    class Meta:
        table_name = 'wannianli'


class WannianliJieqi(BaseModel):
    bailu = TextField()
    chuxi = TextField()
    daxue = TextField()
    hanlu = TextField()
    jingzhe = TextField()
    lichun = TextField()
    lidong = TextField()
    liqiu = TextField()
    lixia = TextField()
    mangzhong = TextField()
    nianfen = IntegerField()
    qingming = TextField()
    xiaohan = TextField()
    xiaoshu = TextField()

    class Meta:
        table_name = 'wannianli_jieqi'


class Wuxing(BaseModel):
    desc1 = TextField(null=True)
    desc2 = TextField(null=True)
    effect1 = FloatField(null=True)
    effect2 = FloatField(null=True)
    guanxi = TextField(null=True)
    wuxing1 = TextField(null=True)
    wuxing2 = TextField(null=True)

    class Meta:
        table_name = 'wuxing'


class Yima(BaseModel):
    chong = TextField(null=True)
    dizhi = TextField(null=True)
    sanhe = TextField(null=True)
    shoushen = TextField(null=True)

    class Meta:
        table_name = 'yima'


class Zaisha(BaseModel):
    dizhi = TextField(null=True)
    nianzhi = TextField(null=True)
    rizhi = TextField(null=True)

    class Meta:
        table_name = 'zaisha'


class Zhangsheng(BaseModel):
    dizhi = TextField(null=True)
    tiangan = TextField(null=True)
    zhangsheng = TextField(null=True)

    class Meta:
        table_name = 'zhangsheng'
